## seqan2 2.5.0~rc2+dfsg

=== CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /CMakeLists.txt
#
# Main CMakeLists.txt file.
# ===========================================================================

# ===========================================================================
# We require CMake 3.12. Since it is available in the currently stable
# Debian, it should be available everywhere else, too.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)

project (seqan CXX)

# ===========================================================================
# Warn People About the Perils Of In-Source Builds
# ===========================================================================

if (EXISTS "$CMAKE_BINARY_DIR/CMakeLists.txt")
  if (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
    set (IN_SOURCE_BUILD YES)
  else (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
    message ("CAUTION: In-source builds are not allowed by default!")
    message ("")
    message ("(If you want to use Eclipse and have read the 'Getting Started,")
    message ("with Eclipse Tutorial' then see the instructions below.)")
    message ("")
    message ("Instead of doing in source builds, go to into the directory build")
    message ("and call CMake from there.")
    message ("We recommend you to create an additional directory level, this")
    message ("allows you to have multiple build configurations (e.g. Debug,")
    message ("Release) or project types.")
    message ("")
    message ("  cd build")
    message ("  mkdir Debug")
    message ("  cd Debug")
    message ("  cmake ../.. -DCMAKE_BUILD_TYPE=Debug")
    message ("")
    message ("NOTE: CMake has created some files in this directory that you have")
    message ("to remove before executing the above commands.")
    message ("")
    message ("  [Linux, Mac Os X]  rm -rf CMakeCache.txt CMakeFiles")
    message ("  [Windows]          del CMakeCache.txt ; rmdir /S CMakeFiles")
    message ("")
    message ("If you want to use Eclipse then you might want to have in-source")
    message ("builds because of limitations of Eclipse CDT4.  In this case")
    message ("Create a file in this directory called I_WANT_IN_SOURCE_BUILDS:")
    message ("")
    message ("  [Linux, Mac Os X]  touch I_WANT_IN_SOURCE_BUILDS")
    message ("  [Windows]          type nul >> I_WANT_IN_SOURCE_BUILDS")
    message ("")
    message (FATAL_ERROR "Please follow the instructions above.")
  endif (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
endif (EXISTS "$CMAKE_BINARY_DIR/CMakeLists.txt")

# ===========================================================================
# Setup Variables
# ===========================================================================

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING
         "Choose the type of build, options are: Debug Release RelWithDebInfo ..."
         FORCE)
endif (NOT CMAKE_BUILD_TYPE)

# Clear CTD executable list, will be set on reconfiguration.
set (SEQAN_CTD_EXECUTABLES CACHE INTERNAL "Global list of executables for workflow integration.")

# ===========================================================================
# Build System Configuration Variables
# ===========================================================================

option (SEQAN_STATIC_APPS "Build static apps." OFF)
option (SEQAN_ARCH_SSE4 "Build SSE optimized binaries." OFF)
option (SEQAN_ARCH_AVX2 "Build AVX2 optimized binaries." OFF)
option (SEQAN_ARCH_AVX512_KNL "Build AVX512 optimized binaries for Knights Landing." OFF)
option (SEQAN_ARCH_AVX512_SKX "Build AVX512 optimized binaries for Skylake." OFF)
option (SEQAN_ARCH_AVX512_CNL "Build AVX512 optimized binaries for Cannon Lake." OFF)
option (SEQAN_ARCH_NATIVE "Build natively optimized binaries." OFF)

# ===========================================================================
# Version Check Variables.
# ===========================================================================

option (SEQAN_VERSION_CHECK_OPT_IN "Enable version check but activate as opt-in." OFF)
option (SEQAN_DISABLE_VERSION_CHECK "Disable version check." OFF)

# ===========================================================================
# Setup Modules and Find Packages.
# ===========================================================================

# Note that the find modules in util/make take precedence
# over the built-in ones from CMake.  This is used in
# FindBZip2, for example which we slightly modify.
set (CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}/util/cmake/FindTBB
    ${CMAKE_CURRENT_SOURCE_DIR}/util/cmake
    ${CMAKE_MODULE_PATH})

#message (STATUS "CMAKE_MODULE_PATH is ${CMAKE_MODULE_PATH}")

# ===========================================================================
# Add contrib to CMAKE_FIND_ROOT_PATH.
# ===========================================================================

include (SeqAnContribs)

# ===========================================================================
# Build Mode Branches
# ===========================================================================

message (STATUS "Initializing SeqAn Build System...")

set (SEQAN_USE_SEQAN_BUILD_SYSTEM TRUE CACHE INTERNAL "Use SeqAn build system." FORCE)

#set (SEQAN_PREFIX_SHARE .)
include (SeqAnBuildSystem)
set (SEQAN_ROOT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE INTERNAL "Root source directory." FORCE)
seqan_get_version ()
seqan_build_system_init ()
seqan_get_repository_info ()

# ===========================================================================
# Include Subdirectories
# ===========================================================================

# Tests, demos and manual are only built when building in DEVELOP mode.
if ("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    message (STATUS "Configuring tests")
    add_subdirectory (tests)

    message (STATUS "Configuring demos")
    add_subdirectory (demos)

    if (NOT SEQAN_NO_DOX)
        message (STATUS "Configuring manual")
        add_subdirectory (manual)
    endif ()
endif ()

if ((("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP") OR
     ("${SEQAN_BUILD_SYSTEM}" STREQUAL "SEQAN_RELEASE_LIBRARY")) AND
     (NOT SEQAN_NO_DOX))

    message (STATUS "Configuring dox")
    add_subdirectory (dox)

    if ("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
        message (STATUS "Configuring util/py_lib")
        add_subdirectory (util/py_lib)
    endif ()
endif ()

if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "SEQAN_RELEASE_LIBRARY")
    message (STATUS "Configuring apps")
    add_subdirectory (apps)
endif ()

# ===========================================================================
# Register Libraries (for GUI project generators)
# ===========================================================================

seqan_setup_library ()

# ===========================================================================
# Include CPack
# ===========================================================================

include (package)

# ===========================================================================
# Check Optional Libraries, Print Usage
# ===========================================================================

#include (FeatureSummary)

# ===========================================================================
# Setup Common Tool Description for Generic Workflow Nodes
# ===========================================================================

include (SeqAnCtdSetup)

=== manual/requirements.txt ===
sphinx==5.3.0
seqansphinx>=0.4.0
sphinx_rtd_theme
sphinxcontrib-bibtex
nose2
jinja2

=== apps/fiona/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: apps/fiona/CMakeLists.txt
#
# CMakeLists.txt file for fiona.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_fiona CXX)
message (STATUS "Configuring apps/fiona")

set (SEQAN_APP_VERSION "0.2.11")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (Boost)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# Stop here if we cannot find Boost or OpenMP.
if (NOT Boost_FOUND)
    message (STATUS "  Skipping fiona, missing Boost")
    return ()
endif ()

if (NOT OPENMP_FOUND)
    message (STATUS "  Skipping fiona, missing OpenMP")
    return ()
endif ()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message (STATUS "  Skipping fiona on 32-bit architectures")
    return ()
endif()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})
include_directories (SYSTEM ${Boost_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})
#add_definitions("-DQGRAM_LENGTH=5")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (compute_gain compute_gain.cpp)
add_executable (fiona fiona.cpp)
add_executable (fiona_illumina fiona.cpp)

set_target_properties (fiona_illumina PROPERTIES COMPILE_DEFINITIONS "FIONA_ILLUMINA")

# Boost 1.74.0 is not compatible with cpp20
set_property(TARGET fiona PROPERTY CXX_STANDARD 17)
set_property(TARGET fiona_illumina PROPERTY CXX_STANDARD 17)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (compute_gain ${SEQAN_LIBRARIES})
target_link_libraries (fiona ${SEQAN_LIBRARIES})
target_link_libraries (fiona_illumina ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fiona)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fiona in ${PREFIX}/bin directory
install (TARGETS fiona fiona_illumina compute_gain DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fiona for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/reads.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------
if (NOT MSVC)
    seqan_add_app_test (fiona)
else ()
    message (STATUS "  Skipping fiona tests on Visual Studio")
endif ()

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable fiona in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fiona fiona_illumina compute_gain CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (fiona)
seqan_add_ctd_test (fiona_illumina)
seqan_add_ctd_test (compute_gain)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")
  set (CPACK_PACKAGE_NAME "fiona")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fiona")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (fiona "fiona")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")

=== apps/mason2/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /mason2/CMakeLists.txt
#
# CMakeLists.txt file for mason2.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_mason2 CXX)
message (STATUS "Configuring apps/mason2")

set (SEQAN_APP_VERSION "2.0.10")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: MASON2 will not be built.")
  return ()
endif (NOT ZLIB_FOUND)

# Enable C++11 in GCC and/or CLANG.
#if (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)
#    add_definitions ("-std=c++0x")
#endif (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# We define a library for the reusable parts of Mason.
add_library (mason_sim
             external_split_merge.h
             external_split_merge.cpp
             fragment_generation.h
             genomic_variants.h
             genomic_variants.cpp
             individual_genome.h
             mason_options.cpp
             mason_options.h
             mason_types.h
             methylation_levels.cpp
             methylation_levels.h
             omp_wrapper.h
             sequencing.h
             simulate_454.cpp
             simulate_base.cpp
             simulate_genome.cpp
             simulate_genome.h
             simulate_illumina.cpp
             simulate_sanger.cpp
             variation_size_tsv.h
             vcf_materialization.cpp
             vcf_materialization.h)
target_link_libraries (mason_sim ${SEQAN_LIBRARIES})


# Simulate random genomes.
add_executable (mason_genome mason_genome.cpp)

# Simulate methylation levels for gnome.
add_executable (mason_methylation mason_methylation.cpp)

# Simulate sequencing of fragments.
add_executable (mason_frag_sequencing mason_frag_sequencing.cpp)

# Simulation of structural variants into FASTA sequences.
add_executable (mason_variator mason_variator.cpp)

# The materializer reads in FASTA and VCF and writes out FASTA.
add_executable (mason_materializer mason_materializer.cpp)

# The end-to-end read simulator includes materialization and fragment sampling.
add_executable (mason_simulator mason_simulator.cpp)

# Simulation splicing given a reference, GFF/GTF file, and possibly VCF for variants.
add_executable (mason_splicing mason_splicing.cpp)

# Tests for some of the library functionality.
add_executable (mason_tests mason_tests.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (mason_frag_sequencing mason_sim)
target_link_libraries (mason_genome mason_sim)
target_link_libraries (mason_materializer mason_sim)
target_link_libraries (mason_methylation mason_sim)
target_link_libraries (mason_simulator mason_sim)
target_link_libraries (mason_splicing mason_sim)
target_link_libraries (mason_tests mason_sim)
target_link_libraries (mason_variator mason_sim)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include mason executables in CTD structure.
set (SEQAN_CTD_EXECUTABLES
    ${SEQAN_CTD_EXECUTABLES}
    mason_genome
    mason_frag_sequencing
    mason_variator
    mason_materializer
    mason_simulator
    CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (mason_genome)
seqan_add_ctd_test (mason_frag_sequencing)
seqan_add_ctd_test (mason_variator)
seqan_add_ctd_test (mason_materializer)
seqan_add_ctd_test (mason_simulator)

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (mason2)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install Mason binaries in ${PREFIX}/bin directory
install (TARGETS mason_frag_sequencing
                 mason_genome
                 mason_materializer
                 mason_methylation
                 mason_simulator
                 mason_splicing
                 mason_variator
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/mason2 for SeqAn release builds.
install (FILES LICENSE
               README
               README.mason_frag_sequencing
               README.mason_genome
               README.mason_materializer
               README.mason_methylation
               README.mason_simulator
               README.mason_splicing
               README.mason_variator
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/adeno_virus.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

if (NOT MSVC)
    seqan_add_app_test (mason2)
else ()
    message (STATUS "  Skipping mason2 tests on Visual Studio")
endif ()

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")
  set (CPACK_PACKAGE_NAME "mason2")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Versatile package for the simulation of nucleic sequence.")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (mason2 "mason2")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")

=== apps/razers3/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/razers3/CMakeLists.txt
#
# CMakeLists.txt file for razers3.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_razers3 CXX)
message (STATUS "Configuring apps/razers3")

set (SEQAN_APP_VERSION "3.5.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (BZip2)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (razers3 razers.cpp
                        razers.h
                        job_queue.h
                        outputFormat.h
                        parallel_job_queue.h
                        parallel_misc.h
                        parallel_store.h
                        paramChooser.h
                        param_tabs.cpp
                        param_tabs.inc
                        param_tabs.h
                        profile_timeline.h
                        razers_match_filter.h
                        razers_paired_match_filter.h
                        razers_matepairs.h
                        razers_matepairs_parallel.h
                        razers_parallel.h
                        razers_window.h
                        readSimulator.h)

#add_executable (razers3_compPHSens compPHSens.cpp razers.h)

add_executable (razers3_simulate_reads simulate_reads.cpp)

add_executable (razers3_quality2prob quality2prob.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (razers3 ${SEQAN_LIBRARIES})
target_link_libraries (razers3_simulate_reads ${SEQAN_LIBRARIES})
target_link_libraries (razers3_quality2prob ${SEQAN_LIBRARIES})
#target_link_libraries (razers3_compPHSens ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (razers3)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install razers3 in ${PREFIX}/bin directory
install (TARGETS razers3
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/razers3 for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/genome.fa
               example/reads.fa
               example/reads2.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

# Both tests are always executed; without OpenMP the first one is serial, too
seqan_add_app_test (razers3)
seqan_add_app_test (razers3 _sequential)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} razers3 CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (razers3)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:razers3")
  set (CPACK_PACKAGE_NAME "razers3")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "razers3 - Faster, fully sensitive read mapping.")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (razers3 "razers3")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:razers3")

=== apps/samcat/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/samcat/CMakeLists.txt
#
# CMakeLists.txt file for samcat.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_samcat CXX)
message (STATUS "Configuring apps/samcat")

set (SEQAN_APP_VERSION "0.3.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: samcat will not be built.")
  return ()
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (samcat samcat.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (samcat ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (samcat)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install samcat in ${PREFIX}/bin directory
install (TARGETS samcat
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/samcat for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES example/fasta1.fa
#               example/fasta2.fa
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (samcat)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} samcat CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (samcat)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:samcat")
  set (CPACK_PACKAGE_NAME "samcat")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Concatenate SAM or BAM files")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (samcat "samcat")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:samcat")

=== apps/searchjoin/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/searchjoin/CMakeLists.txt
#
# CMakeLists.txt file for searchjoin.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_searchjoin CXX)
message (STATUS "Configuring apps/searchjoin")

set (SEQAN_APP_VERSION "0.5.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS} -DSEARCHJOIN_HUGEDB=TRUE)

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (s4_search search.cpp finder.h db.h verifier.h writer.h)
add_executable (s4_join join.cpp finder.h db.h verifier.h writer.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (s4_search ${SEQAN_LIBRARIES})
target_link_libraries (s4_join ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (searchjoin)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install searchjoin in ${PREFIX}/bin directory
install (TARGETS s4_search s4_join
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/searchjoin for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (searchjoin)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:searchjoin")
  set (CPACK_PACKAGE_NAME "searchjoin")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "searchjoin")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Enrico Siragusa <enrico.siragusa@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Enrico Siragusa <enrico.siragusa@fu-berlin.de>")

  seqan_configure_cpack_app (searchjoin "searchjoin")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:searchjoin")

=== apps/yara/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/yara/CMakeLists.txt
#
# CMakeLists.txt file for yara.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_yara CXX)
message (STATUS "Configuring apps/yara")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (BZip2)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# Warn if OpenMP was not found.
if (NOT OPENMP_FOUND)
  message (STATUS "  Could NOT find OpenMP 3.0: building without multi-threading")
endif (NOT OPENMP_FOUND)

# Warn if Zlib was not found.
if (NOT ZLIB_FOUND)
  message (STATUS "  Could NOT find zlib: building without gzipped input and BAM output support")
endif (NOT ZLIB_FOUND)

# Warn if BZip2 was not found.
if (NOT BZIP2_FOUND)
  message (STATUS "  Could NOT find bzip2: building without bzipped input support")
endif (NOT BZIP2_FOUND)

# ----------------------------------------------------------------------------
# App-Level Configuration
# ----------------------------------------------------------------------------

set (SEQAN_APP_VERSION "1.0.3")

option (YARA_LARGE_CONTIGS "Set to OFF to disable support for more than 32k contigs or contigs longer than 4Gbp." ON)
if (YARA_LARGE_CONTIGS)
  add_definitions (-DYARA_LARGE_CONTIGS=1)
endif (YARA_LARGE_CONTIGS)

# ----------------------------------------------------------------------------
# Disable Compiler Warnings
# ----------------------------------------------------------------------------

# Disables warning about conversion from 64 bit to 32 bit integrals.
# Note that there is a runtime exception thrown if the type is not sufficient.
# Unfortunately the VC does not detect it.
if (MSVC)
    set (SEQAN_CXX_FLAGS "${SEQAN_CXX_FLAGS} /wd4244")  # When compiling on 32 bit windows.
    set (SEQAN_CXX_FLAGS "${SEQAN_CXX_FLAGS} /wd4267")  # When compiling on 64 bit windows.
endif (MSVC)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Update the list of file names below if you add source files to your application.
add_executable(yara_indexer indexer.cpp
                            misc_tags.h
                            misc_timer.h
                            misc_options.h
                            misc_types.h
                            store_seqs.h
                            bits_matches.h
                            index_fm.h)

add_executable(yara_mapper    mapper.cpp
                              mapper.h
                              mapper_collector.h
                              mapper_classifier.h
                              mapper_ranker.h
                              mapper_filter.h
                              mapper_extender.h
                              mapper_verifier.h
                              mapper_aligner.h
                              mapper_writer.h
                              basic_alphabet.h
                              file_pair.h
                              file_prefetched.h
                              store_seqs.h
                              misc_tags.h
                              misc_timer.h
                              misc_options.h
                              misc_types.h
                              bits_reads.h
                              bits_hits.h
                              bits_matches.h
                              bits_context.h
                              bits_seeds.h
                              bits_bucket.h
                              find_extender.h
                              find_verifier.h
                              index_fm.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (yara_indexer ${SEQAN_LIBRARIES})
target_link_libraries (yara_mapper ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (yara)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install yara in ${PREFIX}/bin directory
install (TARGETS yara_indexer yara_mapper
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/yara for SeqAn release builds.
install (FILES LICENSE README.rst
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (yara)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable yara_mapper in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES}
                           yara_indexer yara_mapper CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (yara_indexer)
seqan_add_ctd_test (yara_mapper)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:yara")
  set (CPACK_PACKAGE_NAME "yara")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Yara - Yet Another Read Aligner")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Enrico Siragusa <enrico.siragusa@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")
  set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.rst")

  seqan_configure_cpack_app (yara "yara")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:yara")

=== tests/index/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /tests/index/CMakeLists.txt
#
# CMakeLists.txt file for the index module tests.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_tests_index CXX)
message (STATUS "Configuring tests/index")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (SeqAn REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Update the list of file names below if you add source files to your test.
add_executable (test_index_creation
                test_index_creation.cpp
                test_index_creation.h
                test_index_helpers.h)
target_link_libraries (test_index_creation ${SEQAN_LIBRARIES})

add_executable (test_index_crosscompare_char
                test_index_crosscompare_char.cpp
                test_crosscompare.h)
target_link_libraries (test_index_crosscompare_char ${SEQAN_LIBRARIES})

# We need an additional TU for the DFI test otherwise GCC 4.7 warns in 32 bit mode.
add_executable (test_index_crosscompare_char_dfi
                test_index_crosscompare_char_dfi.cpp
                test_crosscompare.h)
target_link_libraries (test_index_crosscompare_char_dfi ${SEQAN_LIBRARIES})

add_executable (test_index_crosscompare_dna
                test_index_crosscompare_dna.cpp
                test_crosscompare.h)
target_link_libraries (test_index_crosscompare_dna ${SEQAN_LIBRARIES})

# We need an additional TU for the DFI test otherwise GCC 4.7 warns in 32 bit mode.
add_executable (test_index_crosscompare_dna_dfi
                test_index_crosscompare_dna_dfi.cpp
                test_crosscompare.h)
target_link_libraries (test_index_crosscompare_dna_dfi ${SEQAN_LIBRARIES})

add_executable (test_index_qgram
                test_index_qgram.cpp
                test_qgram_index.h)
target_link_libraries (test_index_qgram ${SEQAN_LIBRARIES})

add_executable (test_index_sa_bwtwalk
                test_index_sa_bwtwalk.cpp
                test_sa_bwtwalk.h)
target_link_libraries (test_index_sa_bwtwalk ${SEQAN_LIBRARIES})

add_executable (test_index_shapes
                test_index_shapes.cpp
                test_shapes.h)
target_link_libraries (test_index_shapes ${SEQAN_LIBRARIES})

add_executable (test_index_drawing
                test_index_drawing.cpp)
target_link_libraries (test_index_drawing ${SEQAN_LIBRARIES})

#add_executable (test_index_fm_right_array_binary_tree
#                test_index_fm_right_array_binary_tree.cpp
#                test_index_fm_right_array_binary_tree.h
#                test_index_fm_right_array_binary_tree_iterator.h
#                test_index_helpers.h)
#target_link_libraries (test_index_fm_right_array_binary_tree ${SEQAN_LIBRARIES})

add_executable (test_index_fm_rank_dictionary
                test_index_fm_rank_dictionary.cpp
                test_index_helpers.h)
target_link_libraries (test_index_fm_rank_dictionary ${SEQAN_LIBRARIES})

add_executable (test_index_fm_sparse_string
                test_index_fm_sparse_string.cpp)
target_link_libraries (test_index_fm_sparse_string ${SEQAN_LIBRARIES})

add_executable (test_index_base
                test_index_base.cpp
                test_index_helpers.h)
target_link_libraries (test_index_base ${SEQAN_LIBRARIES})

add_executable (test_index_fm
                test_index_fm.cpp
                test_index_helpers.h)
target_link_libraries (test_index_fm ${SEQAN_LIBRARIES})

add_executable (test_index_bifm
                test_index_bifm.cpp
                test_index_helpers.h)
target_link_libraries (test_index_bifm ${SEQAN_LIBRARIES})

add_executable (test_index_vstree
                test_index_vstree.cpp
                test_index_fm_stree.h
                test_index_helpers.h)
target_link_libraries (test_index_vstree ${SEQAN_LIBRARIES})

# GCC < 4.5 segfaults when compiling the test_index_stree_iterators test.
# Enable if the compiler is not GCC or the version is >= 4.5.
if (NOT CMAKE_COMPILER_IS_GNUCXX OR (450 LESS _GCC_VERSION))
    add_executable (
        test_index_stree_iterators
        test_index_stree_iterators.cpp
        test_stree_iterators.h)
    target_link_libraries (test_index_stree_iterators ${SEQAN_LIBRARIES})
endif ()

add_executable (test_index_view
                test_index_view.cpp
                test_index_view.h)
target_link_libraries (test_index_view ${SEQAN_LIBRARIES})

add_executable (test_index_finder
                test_index_finder.cpp
                test_index_helpers.h)
target_link_libraries (test_index_finder ${SEQAN_LIBRARIES})

add_executable (test_find_backtracking
                test_find_backtracking.cpp
                test_find_backtracking.h
                test_find_base.h)
target_link_libraries (test_find_backtracking ${SEQAN_LIBRARIES})

add_executable (test_find2_index_approx
                test_find2_index_approx.cpp
                test_find2_index_approx.h)
target_link_libraries (test_find2_index_approx ${SEQAN_LIBRARIES})

add_executable (test_index_repeats
               test_index_repeats.cpp
               test_index_repeats.h)
target_link_libraries (test_index_repeats ${SEQAN_LIBRARIES})

add_executable (test_index_swift
                test_index_swift.cpp)
target_link_libraries (test_index_swift ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Register with CTest
# ----------------------------------------------------------------------------

add_test (NAME test_test_index_creation COMMAND $<TARGET_FILE:test_index_creation>)
add_test (NAME test_test_index_crosscompare_char COMMAND $<TARGET_FILE:test_index_crosscompare_char>)
add_test (NAME test_test_index_crosscompare_char_dfi COMMAND $<TARGET_FILE:test_index_crosscompare_char_dfi>)
add_test (NAME test_test_index_crosscompare_dna COMMAND $<TARGET_FILE:test_index_crosscompare_dna>)
add_test (NAME test_test_index_crosscompare_dna_dfi COMMAND $<TARGET_FILE:test_index_crosscompare_dna_dfi>)
add_test (NAME test_test_index_qgram COMMAND $<TARGET_FILE:test_index_qgram>)
add_test (NAME test_test_index_sa_bwtwalk COMMAND $<TARGET_FILE:test_index_sa_bwtwalk>)
add_test (NAME test_test_index_shapes COMMAND $<TARGET_FILE:test_index_shapes>)
add_test (NAME test_test_index_drawing COMMAND $<TARGET_FILE:test_index_drawing>)
#add_test (NAME test_test_index_fm_right_array_binary_tree COMMAND $<TARGET_FILE:test_index_fm_right_array_binary_tree>)
add_test (NAME test_test_index_fm_rank_dictionary COMMAND $<TARGET_FILE:test_index_fm_rank_dictionary>)
add_test (NAME test_test_index_fm_sparse_string COMMAND $<TARGET_FILE:test_index_fm_sparse_string>)
add_test (NAME test_test_index_base COMMAND $<TARGET_FILE:test_index_base>)
add_test (NAME test_test_index_fm COMMAND $<TARGET_FILE:test_index_fm>)
add_test (NAME test_test_index_bifm COMMAND $<TARGET_FILE:test_index_bifm>)
add_test (NAME test_test_index_vstree COMMAND $<TARGET_FILE:test_index_vstree>)
if (NOT CMAKE_COMPILER_IS_GNUCXX OR (450 LESS _GCC_VERSION))
    add_test (NAME test_test_index_stree_iterators COMMAND $<TARGET_FILE:test_index_stree_iterators>)
endif ()
add_test (NAME test_test_index_view COMMAND $<TARGET_FILE:test_index_view>)
add_test (NAME test_test_index_finder COMMAND $<TARGET_FILE:test_index_finder>)
add_test (NAME test_test_find_backtracking COMMAND $<TARGET_FILE:test_find_backtracking>)
add_test (NAME test_test_index_repeats COMMAND $<TARGET_FILE:test_index_repeats>)

=== tests/journaled_string_tree/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: tests/journaled_string_tree/CMakeLists.txt
#
# CMakeLists.txt file for the journaled_string_tree module tests.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_tests_journaled_string_tree CXX)
message (STATUS "Configuring tests/journaled_string_tree")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (SeqAn REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

add_executable (test_basic_observable
                test_basic_observable.cpp
                test_basic_observable.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_basic_observable ${SEQAN_LIBRARIES})

# Update the list of file names below if you add source files to your test.
add_executable (test_journaled_string_tree
                test_journaled_string_tree.cpp
                test_journaled_string_tree.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_journaled_string_tree ${SEQAN_LIBRARIES})

add_executable (test_delta_map
                test_delta_map.cpp
                test_delta_store.h
                test_delta_map.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_delta_map ${SEQAN_LIBRARIES})

add_executable (test_journaled_string_tree_traverser
                test_journaled_string_tree_traverser.cpp
                test_journaled_string_tree_traverser.h
                test_journaled_string_tree_mock.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_journaled_string_tree_traverser ${SEQAN_LIBRARIES})

add_executable (test_journaled_string_tree_find
                test_journaled_string_tree_find.cpp
                test_journaled_string_tree_find.h
                test_journaled_string_tree_mock.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_journaled_string_tree_find ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Register with CTest
# ----------------------------------------------------------------------------

add_test (NAME test_test_journaled_string_tree COMMAND $<TARGET_FILE:test_journaled_string_tree>)
add_test (NAME test_test_delta_map COMMAND $<TARGET_FILE:test_delta_map>)
add_test (NAME test_journaled_string_tree_traverser COMMAND $<TARGET_FILE:test_journaled_string_tree_traverser>)
add_test (NAME test_journaled_string_tree_find COMMAND $<TARGET_FILE:test_journaled_string_tree_find>)

=== tests/parallel/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /tests/parallel/CMakeLists.txt
#
# CMakeLists.txt file for the parallel module tests.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_tests_parallel CXX)
message (STATUS "Configuring tests/parallel")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (SeqAn REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Update the list of file names below if you add source files to your test.
add_executable (test_parallel
               test_parallel.cpp
               test_parallel_atomic_misc.h
               test_parallel_atomic_primitives.h
               test_parallel_splitting.h
               test_parallel_queue.h
               test_parallel_thread_pool.h
               test_parallel_enumerable_thread_local.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_parallel ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Register with CTest
# ----------------------------------------------------------------------------

add_test (NAME test_test_parallel COMMAND $<TARGET_FILE:test_parallel>)

=== tests/translation/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /tests/translation/CMakeLists.txt
#
# CMakeLists.txt file for the translation module tests.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_tests_translation CXX)
message (STATUS "Configuring tests/translation")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (SeqAn REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Update the list of file names below if you add source files to your test.
add_executable (test_translation test_translation.cpp test_translation.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (test_translation ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Register with CTest
# ----------------------------------------------------------------------------

add_test (NAME test_translation COMMAND $<TARGET_FILE:test_translation>)

=== debian/changelog ===
seqan2 (2.5.0~rc2+dfsg-2) experimental; urgency=medium

  * Can't make docs or the manual yet, "seqansphinx" is not yet packaged

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 16 Aug 2024 14:19:19 +0200

seqan2 (2.5.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream version
  * Resume building razers{,3} everywhere.
  * d/rules: According to upstream, solution_online_search_finder.cpp
    works again, so stop deleting that test

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 16 Aug 2024 13:07:37 +0200

seqan2 (2.5.0~rc1+dfsg-1~0exp1) experimental; urgency=medium

  * debian/libseqan2-dev.docs: README.rst→README.md
  * debian/rules: restore "reproducible=-fixfilepath"

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 14 Aug 2024 17:36:14 +0200

seqan2 (2.5.0~rc1+dfsg-1~0exp0) experimental; urgency=medium

  * d/watch: updated to catch release candidates.
  * New upstream version
  * Rely on pre-initialized dpkg-architecture variables.
  * d/patches: many patches upstreamed and removed.
  * d/rules: remove max build limit for amd64 from 2018.
  * Skip building razers & razers3 on all architectures.
  * d/rules: configure with -DALIGN_SIMD_TEST=FALSE as per upstream, to
    avoid compiling a 256+ level template in debug mode which takes up too
    much memory.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 03 Aug 2024 13:24:50 +0200

=== debian/control ===
Source: seqan2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               python3,
               cmake,
               fakeroot
Build-Depends-Arch: zlib1g-dev,
                    libbz2-dev,
                    libbam-dev,
                    libboost-dev,
                    help2man
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/seqan2
Vcs-Git: https://salsa.debian.org/med-team/seqan2.git
Homepage: https://www.seqan.de/
Rules-Requires-Root: no

Package: seqan-apps
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cwltool | cwl-runner
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: libseqan2-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath
# reproducible=-fixfilepath is needed due to how the tests get their file paths :-(

include /usr/share/dpkg/pkg-info.mk
export HOME=$(CURDIR)/fakehome

include /usr/share/dpkg/architecture.mk

ifneq (,$(filter mips mipsel mips64el,$(DEB_BUILD_ARCH)))
	DEB_CXXFLAGS_MAINT_APPEND+=-mxgot
endif
ifneq (,$(filter mips mipsel,$(DEB_BUILD_ARCH)))
	DEB_CXXFLAGS_MAINT_APPEND+=-g1
	DEB_CFLAGS_MAINT_APPEND+=-g1
endif
# As per upstream's instructions
export DEB_CFLAGS_MAINT_APPEND+=-O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DNDEBUG -O3

# Disable parallel building to save memory
# MAX_PARALLEL=--max-parallel=1

pkgapps=seqan-apps
pkgdev=libseqan2-dev

%:
	dh $@

override_dh_auto_configure-arch:
ifeq ($(DEB_HOST_ARCH),armhf)
	# The following tests FAILED:
	#     46 - test_test_index_crosscompare_dna (Bus error)
	#     52 - test_test_index_fm_rank_dictionary (Bus error)
	sed -i \
	    -e '/ test_test_index_crosscompare_dna /d' \
	    -e '/ test_test_index_fm_rank_dictionary /d' \
	    tests/index/CMakeLists.txt
endif
ifeq ($(DEB_HOST_ARCH),mips)
	# The following tests FAILED:
	#      7 - test_align_parallel_data_structures (Child aborted)
	sed -i \
	    -e '/ test_align_parallel_data_structures /d' \
	    tests/index/CMakeLists.txt
endif
	export DEB_BUILD_ARCH=${DEB_BUILD_ARCH} ; \
	dh_auto_configure --arch -- \
		-DSEQAN_STATIC_APPS=False \
		-DSEQAN_DISABLE_VERSION_CHECK=YES \
		-DALIGN_SIMD_TEST=FALSE \
		-DSEQAN_NO_DOX=1

override_dh_auto_configure-indep:
	dh_auto_configure --indep -B build -- \
		-DSEQAN_BUILD_SYSTEM=SEQAN_RELEASE_LIBRARY -DSEQAN_NO_DOX=1 \
		-DSEQAN_DISABLE_REVISION_INFO=1

override_dh_auto_build-arch:
	dh_auto_build --arch ${MAX_PARALLEL}
	# can't make dox, "seqansphinx" is not yet packaged

override_dh_auto_install-indep:
	dh_auto_install --indep -B build --destdir=$(CURDIR)/debian/$(pkgdev)/
	rm -Rf $(CURDIR)/debian/$(pkgdev)/usr/share/doc/seqan

override_dh_install-indep:
	dh_install --indep
	# Delete additional LICENSE and compiled Python files
	if [ -d $(CURDIR)/debian/$(pkgdev) ] ; then \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name LICENSE -delete ; \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name "*.pyc" -delete ; \
	fi

override_dh_install-arch:
	dh_install --arch
	# Delete additional LICENSE files
	find $(CURDIR)/debian/$(pkgapps) -type f -name LICENSE -delete || /bin/true
	find $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin -type f \
		-name "*.sh" | xargs chmod a+x
#	for app in $$(ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin); \
#		do $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/$${app} \
#		--write-ctd $${app}.ctd && CTDConverter cwl -i $${app}.ctd \
#		-o $(CURDIR)/debian/$(pkgapps)/usr/share/commonwl/${app}.cwl; \
#	        done;
#	rm *.ctd
#	find $(CURDIR)/debian/$(pkgapps)/usr/share/commonwl -type f \
#		-name "*.cwl" | xargs chmod a+x

override_dh_auto_clean:
	dh_auto_clean
	find . -type f -name "*.pyc" -delete
	if [ -d orig ] ; then \
	  for header in `find orig -name "*generated_forwards.h"` ; do \
	    mv $${header} `echo $$header | sed 's?orig/??'` ; \
	  done ; \
	fi
	rm -rf orig

override_dh_installman-arch:
	dh_link --arch
	if [ -d $(CURDIR)/debian/$(pkgapps)/usr/bin ] ; then \
		find $(CURDIR)/debian/$(pkgapps)/usr/bin -type l -xtype l -delete ; \
	fi
	$(CURDIR)/debian/generate_manpages
	dh_installman --arch

override_dh_link-arch:
	dh_link --arch
	# Some binaries (eg. splazer) are not built in 32-bit architectures so
	# remove their (broken) symlinks.
	if [ -d $(CURDIR)/debian/$(pkgapps)/usr/bin ] ; then \
	    find $(CURDIR)/debian/$(pkgapps)/usr/bin -type l -xtype l -delete ; \
	fi

override_dh_fixperms-arch:
	dh_fixperms --arch
	for bin in `ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/*.sh` ; do \
	    chmod +x $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/`basename $${bin}` ; \
	done
